# Spica::Data
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2005 SimpleBoxes/SerendipityNZ Ltd. ==
# == Copyright (C) 2005 Spica Project Kei/Fuco/Takkyun ==

# ======================================
package Spica::Data;
use strict;
use Spica;
use Spica::Object;
use base qw( Spica::Object );
use vars qw( $VERSION );
$VERSION = '0.04';
# 0.04 [2006/07/04] changed add to call create_new instead of create
# 0.03 [2006/07/04] got rid of "return( undef )"
# 0.02 [2006/03/29] added count
# 0.01 [2006/03/06] use Spica->get->driver instead of Spica::Driver->get
# 0.00 [2005/10/20] generated
# --------------------------------------
# // public functions - class method
sub load
{
	my $class = shift() . '::' . shift();
	&Spica::Object::load_module($class) or return;
	my %param = ( # input parameters
		'cond'  => {},    # searching option
		'id'    => undef, # inidicates id to load directly
		'logic' => 'and', # logic factor for searching option
		'bgn'   => 0,     # offset of objects to load
		'num'   => -1,    # maximum of objects to load
		'sort'  => 'id',  # sorting option
		'order' => 0,     # sorting order 0:descent 1:ascent
		@_
	);
	return if (!Spica->get->driver);
	my @array = Spica->get->driver->load($class,%param);
	return ($#array == 0) ?  $array[0] : @array;
}
sub load_as_hash
{
	my $class = shift;
	my @array = $class->load(@_);
	return if ( !@array );
	return map { $_->id => $_ } @array;
}
sub count
{
	my $class = shift() . '::' . shift();
	&Spica::Object::load_module($class) or return;
	my %param = ( # input parameters
		'cond'  => {},    # searching option
		'id'    => undef, # inidicates id to load directly
		'logic' => 'and', # logic factor for searching option
		'bgn'   => 0,     # offset of objects to load
		'num'   => -1,    # maximum of objects to load
		'sort'  => 'id',  # sorting option
		'order' => 0,     # sorting order 0:descent 1:ascent
		@_
	);
	return if (!Spica->get->driver);
	return Spica->get->driver->count($class,%param);
}
sub matched
{
	return if (!Spica->get->driver);
	return Spica->get->driver->matched_number;
}
sub update
{
	my $class = shift;
	my @objs  = @_; # objects to save
	return if (!Spica->get->driver);
	Spica->get->driver->save(@objs);
}
sub add
{
	my $class = shift() . '::' . shift();
	my %param = @_;
	&Spica::Object::load_module($class) or return;
	return if (!Spica->get->driver);
	$param{'id'} = Spica->get->driver->new_id($class);
	return $class->create_new(%param);
}
1;
__END__
