# Spica::Data::Session
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ Ltd. ==
# == Copyright (C) 2005 Spica Project Kei/Fuco/Takkyun ==

# ======================================
package Spica::Data::Session;
use strict;
use Spica::Data::Object;
use base qw( Spica::Data::Object );
use vars qw( $VERSION );
$VERSION = '0.05';
# 0.05 [2006/07/04] got rid of "return( undef )"
# 0.04 [2006/03/17] changed bracket rule
# 0.03 [2006/02/26] replaced elements to table
# 0.02 [2005/10/21] changed data structre
# 0.01 [2005/04/18] added check_expire
# 0.00 [2005/03/15] generated
# --------------------------------------
# // override base class
sub table
{
	my $self = shift;
	return (
		'id'   => 'uni_id',   # id
		'key'  => 'str(255)', # key for session
		'data' => 'str(255)', # session date
	);
}
# --------------------------------------
# // public functions
sub check_expire
{
	my $self = shift;
	my %param = (
		'now'      => undef,
		'duration' => undef,
		@_
	);
	if ( $param{'now'} and $param{'duration'} )
	{
		my $diff_time = $param{'now'} - ( split('_',$self->data) )[0];
		return( $diff_time <= $param{'duration'} );
	}
	return;
}
1;
__END__
