# Spica::InitLoader
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2005 SimpleBoxes/SerendipityNZ Ltd. ==
# == Copyright (C) 2005 Spica Project Kei/Fuco/Takkyun ==

# ======================================
package Spica::InitLoader;
use strict;
use Spica::Object;
use base qw( Spica::Object );
use vars qw( $VERSION );
$VERSION = '0.01';
# 0.01 [2006/07/04] got rid of "return undef"
# 0.00 [2006/04/06] created
# --------------------------------------
# // defines / static variables
# ... nothing ...
# --------------------------------------
# // override base class
sub initialize
{
	my $self = shift;
	my %param = (
		'file' => undef,
		'rule' => undef,
		@_
	);
	$self->SUPER::initialize(%param);
	$self->generate_accessor(keys %param);
	$self;
}
# --------------------------------------
# // public functions
sub load
{
	my $self = shift;
	my $targ = shift;
	my $file = $self->file;
	return if ($file eq '' or !-r $file);
	open(INIFILE,"<$file") or return;
	binmode(INIFILE);
	while (my $line = <INIFILE>)
	{
		$line =~ tr/\x0D\x0A//d;
		next if ($line eq '' or $line =~ /^#/);
		my ($key,$val) = split("\t",$line,2);
		$key = $self->_decode($key);
		$key = &{$self->rule}($key) if ($self->rule and ref($self->rule) eq 'CODE');
		next if ($key eq '');
		if ( ref($targ->{$key}) eq 'HASH' and $val =~ /\t/ )
		{
			my ($hkey,$hval) = split("\t",$val,2);
			$hkey = $self->_decode($hkey);
			$targ->{$key}->{$hkey} = $self->_decode($hval);
		}
		elsif ( ref($targ->{$key}) eq 'ARRAY' or $val =~ /\t/ )
		{
			$targ->{$key} = [map { $self->_decode($_) } split("\t",$val)];
		}
		else
		{
			$targ->{$key} = $self->_decode($val);
		}
	}
	close(INIFILE);
	return 1;
}
# --------------------------------------
# // private functions
sub _decode
{
	my $self = shift;
	my $data = shift;
	$data =~ s/\\(.)/$1 eq 't' and "\t" or $1 eq 'n' and "\n" or "$1"/eg;
	$data;
}
1;
__END__
